//-----------------------------------------------------
// Data Scraping   ( based on code by Daniel Shiffman )
//
// It uses a function called "giveMeTextBetween()" which 
// takes 3 arguments: String, first-substring, second-substring
// and then returns the substring between.
// It also uses a function called "printIt()" which takes 3
// arguments: String-to-print, X-location and Y-location
//
// This example gets the temperaature and weather from a webpage.
// ----------------------------------------------------

String url = "https://forecast.weather.gov/MapClick.php?textField1=42.35866&textField2=-71.05674";
String onelongstring;
String[] lines;
PFont f; // Global font variable
int x = 20; // Horizontal location
int index = 0;
String temp;
int tempInt = 65;
String weather;
int lineCounter = 0;

void setup() {
  background(255);
  size(900,300);
  f = createFont( "Arial", 48, true);
  textFont(f);
  textAlign(LEFT);
  lines = loadStrings(url);
}

void draw() {
  background(180, 190, 180 + tempInt);
  fill (0);
  // Display headline at x location
  textFont(f,32);
  textAlign (LEFT);
 String[] lines = loadStrings(url);
// println(lines.length);
 onelongstring = join(lines, " ");

 temp = giveMeTextBetween( onelongstring,  "class=\"myforecast-current-lrg\">", "&deg;F</p>");
 tempInt = int(temp);                 //-- re-cast Temp String into an integer
// println(tempInt);
 weather = giveMeTextBetween( onelongstring,  "col-sm-10 forecast-text\">", " </div>");
 printIt(temp, 360, 80);
 printIt("degrees.", 400, 80);
 printIt("Tonight:", 30, 150);
 printIt(weather, 30, 195);
 delay(500);
}

void printIt(String getStr, int getX, int startY) {
   text(getStr,getX, startY );
}

// A function that returns a substring between two substrings
String giveMeTextBetween(String s, String startTag, String endTag) { 
  // Find the index of the beginning tag
  int startIndex = s.indexOf(startTag);
  // If I don't find anything
  if (startIndex == -1) {
    return "";
  }
  // Move to the end of the beginning tag
  startIndex += startTag.length();
  // Find the index of the end tag
  int endIndex = s.indexOf(endTag, startIndex); 
  // If I don't find the end tag,
  if (endIndex == -1) {
    return "";
  }
  // Return the text in between
  return s.substring(startIndex, endIndex);
}
